package org.lezione2;

public class CircularArrayQueue<E> implements Coda<E> {

	private int testa;
	private int coda;
	private E[] elementi;
	private int size;
	private int capacit;

	public CircularArrayQueue(int capacit){
		this.capacit = capacit;
		elementi = (E[]) new Object[capacit];
		testa = 0;
		coda = 0;
		size = 0;
	}

	@Override
	public void add(E elemento) {
		if(size==capacit){
			System.out.println("errore coda piena");
			return;
		}
		elementi[coda] = elemento;
		coda = (coda+1) % capacit;
		size++;

	}
	@Override
	public E remove() {
		if(size==0){
			System.out.println("errore coda vuota");
			return null;
		}
		E tmp = elementi[testa];
		elementi[testa]=null;
		testa = (testa+1) % capacit;
		size--;
		return tmp;
	}
	@Override
	public int size() {
		return size;
	}

	public static void main(String[] args) {
		CircularArrayQueue<String> cc = new CircularArrayQueue<String>(3);
		cc.add("P");
		cc.add("i");
		cc.add("s");
		System.out.println(cc.remove());
		cc.add("a");
		System.out.println(cc.remove());
		cc.add("la");
		System.out.println(cc.remove());
		System.out.println(cc.remove());
	}




}
