package org.lezione2;

public class LinkedListCoda<E> implements Coda<E> {

	private Link<E> testa, coda;
	protected int size;

	public LinkedListCoda(){
		testa=coda=null;
		size=0;
	}

	@Override
	public void add(E elemento) {
		Link<E> l = new Link<E>(elemento);
		if(coda==null){
			testa=coda=l;
		}
		else{
			coda.setNext(l);
			coda=l;
		}
		size++;
	}

	@Override
	public E remove() {
		E element=null;
        if (size==0)System.out.println("errore coda vuota");
        else{
                element= testa.getElement();
                testa=testa.getNext();
                size--;
                if(testa==null)
                	coda = null;
                return element;
        }
        return element;
	}

	@Override
	public int size() {
		return size;
	}
	
	public static void main(String[] args) {
		Coda<String> cc = new LinkedListCoda<String>();
		cc.add("P");
		cc.remove();
		cc.add("P");
		cc.add("i");
		cc.add("s");
		System.out.println(cc.remove());
		cc.add("a");
		System.out.println(cc.remove());
		cc.add("la");
		System.out.println(cc.remove());
		System.out.println(cc.remove());
	}

}
