package org.lezione2;

import java.util.Iterator;
import java.util.PriorityQueue;

public class PlayList {
	
	private PriorityQueue<Canzone> playlist;
	
	public PlayList(){
		playlist = new PriorityQueue<Canzone>();
	}
	
	public void addCanzone(Canzone c){
		playlist.add(c);
	}
	
	public void play(){
		Iterator<Canzone> it = playlist.iterator();
		while(it.hasNext()){
			Canzone c = playlist.remove();
			System.out.println(c);
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}
	
	public static void main(String[] args) {
		PlayList pl = new PlayList();
		Canzone c1 = new Canzone("AlbaChiara","Vasco Rossi",1);
		Canzone c2 = new Canzone("Solo per te","Negramaro",3);
		Canzone c3 = new Canzone("Capelli","Nicol Fabi",7);
		Canzone c4 = new Canzone("La favola di Adamo ed Eva","Max Gazz",4);
		Canzone c5 = new Canzone("Viva","Ligabue",5);
		pl.addCanzone(c1);
		pl.addCanzone(c2);
		pl.addCanzone(c3);
		pl.addCanzone(c4);
		pl.addCanzone(c5);
		pl.play();
	}

}
