package org.lezione2;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Comparator;
import java.util.Scanner;
import java.util.Set;
import java.util.TreeSet;

public class Esercizio7 {
	
	public static void main(String[] args) throws FileNotFoundException {
		Set<Impiegato> sortByID = new TreeSet<Impiegato>(new
				Comparator<Impiegato>()
				{
			public int compare(Impiegato a, Impiegato b){
				return a.compareTo(b);
			}
				});
		Set<Impiegato> sortByName = new TreeSet<Impiegato>(new
				Comparator<Impiegato>()
				{
			public int compare(Impiegato a, Impiegato b){
				return a.getNome().compareTo(b.getNome());
			}
				});
		Set<Impiegato> sortByCognome = new TreeSet<Impiegato>(new
				Comparator<Impiegato>()
				{
			public int compare(Impiegato a, Impiegato b){
				return a.getCognome().compareTo(b.getCognome());
			}
				});
		Scanner in = new Scanner(new File("impiegati.txt"));
		while(in.hasNextLine()){
			String[] parti = in.nextLine().split(",");
			Impiegato i = new Impiegato(parti[0],parti[1],Integer.parseInt(parti[2]));
			sortByID.add(i);
			sortByName.add(i);
			sortByCognome.add(i);
		}
	}

}
