package org.lezione2;

public class Link<E> {
	private E element;
	private Link<E> next;

	public Link(E element){
		this(element, null);
	}

	public Link(E element, Link<E> next){
		this.element=element;
		this.next=next;
	}

	public void setNext(Link<E> next){
		this.next= next;
	}

	public E getElement(){
		return element;
	}

	public Link<E> getNext(){
		return next;
	}

	public String toString(){
		return (String) element;
	}
}



